# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::AzureStack::Mgmt::V2017_06_01
  module Models
    #
    # Extended description about the product required for installing it into
    # Azure Stack.
    #
    class ExtendedProduct

      include MsRestAzure

      # @return [String] The URI to the .azpkg file that provides information
      # required for showing product in the gallery.
      attr_accessor :gallery_package_blob_sas_uri

      # @return [String] Specifies the kind of the product (virtualMachine or
      # virtualMachineExtension).
      attr_accessor :product_kind

      # @return [ComputeRole] Specifies kind of compute role included in the
      # package. Possible values include: 'None', 'IaaS', 'PaaS'
      attr_accessor :compute_role

      # @return [Boolean] Specifies if product is a Virtual Machine Extension.
      attr_accessor :is_system_extension

      # @return [String] The URI.
      attr_accessor :uri

      # @return [Boolean] Indicates if specified product supports multiple
      # extensions.
      attr_accessor :support_multiple_extensions

      # @return [String] Specifies product version.
      attr_accessor :version

      # @return [OperatingSystem] Specifies operating system used by the
      # product. Possible values include: 'None', 'Windows', 'Linux'
      attr_accessor :vm_os_type

      # @return [Boolean] Indicates if virtual machine Scale Set is enabled in
      # the specified product.
      attr_accessor :vm_scale_set_enabled

      # @return [OsDiskImage] OS disk image used by product.
      attr_accessor :os_disk_image

      # @return [Array<DataDiskImage>] List of attached data disks.
      attr_accessor :data_disk_images


      #
      # Mapper for ExtendedProduct class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ExtendedProduct',
          type: {
            name: 'Composite',
            class_name: 'ExtendedProduct',
            model_properties: {
              gallery_package_blob_sas_uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'galleryPackageBlobSasUri',
                type: {
                  name: 'String'
                }
              },
              product_kind: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'productKind',
                type: {
                  name: 'String'
                }
              },
              compute_role: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.computeRole',
                type: {
                  name: 'String'
                }
              },
              is_system_extension: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.isSystemExtension',
                type: {
                  name: 'Boolean'
                }
              },
              uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.sourceBlob.uri',
                type: {
                  name: 'String'
                }
              },
              support_multiple_extensions: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.supportMultipleExtensions',
                type: {
                  name: 'Boolean'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.version',
                type: {
                  name: 'String'
                }
              },
              vm_os_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.vmOsType',
                type: {
                  name: 'String'
                }
              },
              vm_scale_set_enabled: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.vmScaleSetEnabled',
                type: {
                  name: 'Boolean'
                }
              },
              os_disk_image: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.osDiskImage',
                type: {
                  name: 'Composite',
                  class_name: 'OsDiskImage'
                }
              },
              data_disk_images: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dataDiskImages',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DataDiskImageElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DataDiskImage'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
